#include <Message.h>
#include <Messenger.h>
#include <Roster.h>

#include "FancySlave.h"
#include "Opcodes.h"

FancySlave::FancySlave()
	:	BLooper("FancyKeyboard bouncer")
{
}

FancySlave::~FancySlave()
{
}

void FancySlave::MessageReceived(BMessage *msg)
{
	switch (msg->what) {
	case opcode::Mute:
	case opcode::VolumeUp:
	case opcode::VolumeDown:
	case opcode::Stop:
	case opcode::PlayPause:
	case opcode::NextTrack:
	case opcode::PrevTrack:
	case opcode::Eject:
	case opcode::PlaySelection:
	case opcode::LastTrack:
	case opcode::FirstTrack:
	case opcode::AddSelection:
	case opcode::Shuffle:
		SendCommand(msg);
		break;
	default:	
		BLooper::MessageReceived(msg);
	}
}

void FancySlave::SendCommand(BMessage *msg)
{
	status_t err;
	BMessenger m(kFancyAppSignature, -1, &err);
	if (err == B_OK)
		m.SendMessage(msg);
	else {
		if (be_roster) {
			BMessage m(opcode::LaunchedFromAddOn);
			m.AddMessage("msg", msg);
			be_roster->Launch(kFancyAppSignature, &m);
		}
		// not much we can do if there's no roster
	}
}
