#ifndef APPLICATION_H
#define APPLICATION_H

#include <Application.h>
#include <Entry.h>

class FancyApp : public BApplication {
public:
	FancyApp();
	~FancyApp();

	void Pulse();
	void MessageReceived(BMessage *msg);
	void RefsReceived(BMessage *msg);

	bool IsPlaying() const;
	bool IsPaused() const;
	bool IsStopped() const;

	void SetCurrent(const entry_ref &, bool play);
	void StopPlaying();

private:
	unsigned AddRefs(BMessage *msg, const char *field = "refs");
	unsigned AddSelection();

	void SaveState();
	void LoadState();

	void Action();

	class FancyPlayer *fPlayer;
	class FancyPlayList *fPlayList;
	class PlayStatusWindow *fPlayWindow;
	class VolumeWindow *fVolumeWin;
	class MessageWindow *fMsgWin;

	entry_ref fCurrentRef;
	bigtime_t fLastAction;
};

#endif
