#ifndef FANCY_DEBUG_H
#define FANCY_DEBUG_H

#include <Debug.h>

void FatalError(const char *);

#if DEBUG
#include <string>
#endif

#define ENTRY DEBUG_ONLY( _fp_FuncTrack _FuncTrackObj(__FUNCTION__); )
#define DENTRY DEBUG_ONLY( _fp_FuncTrack _FuncTrackObj((string("~") + __FUNCTION__).c_str()); )
#define INDENT DEBUG_ONLY( for (unsigned i=0; i<debug_stack_depth(); i++) cout << '\t'; )
#define MESSAGE(x) DEBUG_ONLY( INDENT cout << x << endl; )

DEBUG_ONLY(

unsigned &debug_stack_depth();

struct _fp_FuncTrack {
	_fp_FuncTrack(const char *n) : name(n) { MESSAGE("in:  " << name) debug_stack_depth()++; }
	~_fp_FuncTrack() { debug_stack_depth()--; MESSAGE("out: " << name) }
	string name;
};

)

#endif
