#ifndef FANCY_PLAYLIST_H
#define FANCY_PLAYLIST_H

#include <Entry.h>

#include <vector>

class FancyPlayList {
public:
	typedef vector<entry_ref> entry_vec;

	bool GetNext(const entry_ref &from, entry_ref &result, entry_vec *added = 0, entry_vec *removed = 0);
	bool GetPrevious(const entry_ref &from, entry_ref &result, entry_vec *added = 0, entry_vec *removed = 0);

	bool GetFirst(entry_ref &result, entry_vec *added = 0, entry_vec *removed = 0);
	bool GetLast(entry_ref &result, entry_vec *added = 0, entry_vec *removed = 0);

	void Shuffle();
	unsigned Clean(entry_vec *removed = 0); // remove non-audio files
	unsigned Empty(entry_vec *removed = 0); // remove all files

	unsigned Add(const entry_ref &ref, bool analyze, entry_vec *added = 0);
	unsigned Add(const entry_vec &refs, bool analyze, entry_vec *added = 0);
	unsigned Remove(const entry_ref &ref, entry_vec *removed = 0);
	unsigned Remove(const entry_vec &refs, entry_vec *removed = 0);

	bool ContainsFile(const entry_ref &) const;
	unsigned CountFiles() const { return fList.size(); }

	const entry_vec &GetList() const { return fList; }

private:
	entry_vec fList;
};

#endif
