#include "FancyDebug.h"

#include <Font.h>
#include <StringView.h>

#include <string>

#include "MessageWindow.h"

MessageWindow::MessageWindow()
	:	inherited(BRect(-100,-100,-90,-90), "Message", B_NO_BORDER_WINDOW_LOOK, 
			B_FLOATING_ALL_WINDOW_FEEL, B_ASYNCHRONOUS_CONTROLS
				| B_NOT_MOVABLE | B_NOT_CLOSABLE | B_NOT_ZOOMABLE
				| B_NOT_MINIMIZABLE | B_NOT_RESIZABLE | B_AVOID_FOCUS 
				| B_WILL_ACCEPT_FIRST_CLICK, B_ALL_WORKSPACES)
{	ENTRY

	fView = new BStringView(Bounds(), 0, "Should not see this");
	BFont f(be_plain_font);
	f.SetSize(15);
	f.SetFace(B_BOLD_FACE);
	fView->SetFont(&f);
	fView->SetViewColor(0,0,0);
	fView->SetLowColor(0,0,0);
	fView->SetHighColor(50, 190, 255);

	AddChild(fView);

	Place();
}

void MessageWindow::SetText(const char *txt)
{	ENTRY

	Lock();
	fView->SetText(txt);
	Place();
	Unlock();
}

void MessageWindow::AppendText(const char *txt)
{	ENTRY

	Lock();
	fView->SetText((string(Text()) + txt).c_str());
	Unlock();
}

const char *MessageWindow::Text() const
{	ENTRY

	return fView->Text();
}

void MessageWindow::Place()
{	ENTRY

	Lock();
	fView->ResizeToPreferred();
	const BRect frame = fView->Frame();
	ResizeTo(frame.Width(), frame.Height());
	inherited::Place();
	Unlock();
}

void MessageWindow::ShowText(const char *txt)
{	ENTRY

	Lock();
	SetText(txt);
	Show();
	Unlock();
}
