#include "FancyDebug.h"

#include "PlayModeView.h"

PlayModeView::PlayModeView(const BRect &frame)
	:	BView(frame, NULL, B_FOLLOW_NONE, B_WILL_DRAW),
		playMode(Stopped)
{	ENTRY

	SetViewColor(0,0,0);
	SetHighColor(0,255,0);
	SetLowColor(0,0,0);
	SetMode(Stopped);
}

void PlayModeView::Draw(BRect)
{	ENTRY

	BRect bounds = Frame();
	bounds.OffsetTo(0,0);
	const int width = bounds.IntegerWidth();

	switch (playMode) {
	case Playing:
		FillTriangle(bounds.LeftTop(), bounds.LeftBottom(), BPoint(bounds.right*0.78, bounds.IntegerHeight()/2));
		break;
	case Paused:
	{
		int bw = (width*4)/11;
		FillRect(BRect(bw,0,bounds.right-bw,bounds.bottom), B_SOLID_LOW);
		break;
	}
	case Stopped:
		break;
	}
}

void PlayModeView::SetMode(PlayMode pm)
{	ENTRY

	playMode = pm;
	switch (playMode) {
	case Playing:
		SetViewColor(0,0,0);
		break;
	case Paused:
		SetViewColor(255,0,0);
		break;
	case Stopped:
		SetViewColor(0,255,0);
		break;
	}
	Invalidate();
}
