#include "FancyDebug.h"

#include <Message.h>
#include <Messenger.h>

#include "FancyPlayerInterface.h"
#include "PlayStatusView.h"
#include "PlayStatusWindow.h"

PlayStatusWindow::PlayStatusWindow(BLooper *player)
	:	inherited(BRect(-100,-100,-90,-90), "PlayerStatus", B_NO_BORDER_WINDOW_LOOK, 
			B_FLOATING_ALL_WINDOW_FEEL, B_ASYNCHRONOUS_CONTROLS
				| B_NOT_MOVABLE | B_NOT_CLOSABLE | B_NOT_ZOOMABLE
				| B_NOT_MINIMIZABLE | B_NOT_RESIZABLE | B_AVOID_FOCUS 
				| B_WILL_ACCEPT_FIRST_CLICK, B_ALL_WORKSPACES)
{	ENTRY

	fView = new PlayStatusView;
	AddChild(fView);

	BMessage m(FPInterface::RegisterCallback);
	if (m.AddMessenger("messenger", BMessenger(fView, this)) != B_OK)
		FatalError("Unable to add messenger");

	BMessage reply;
	if (BMessenger(player).SendMessage(&m, &reply) != B_OK)
		FatalError("Failed to send watch message to player");

	if (reply.what != B_OK)
		FatalError("Failed to watch player status");

	Place();
}

void PlayStatusWindow::Place()
{	ENTRY

	Lock();
	fView->ResizeToPreferred();
	const BRect frame = fView->Frame();
	ResizeTo(frame.Width(), frame.Height());
	inherited::Place();
	Unlock();
}

void PlayStatusWindow::MessageReceived(BMessage *msg)
{	ENTRY

	switch (msg->what) {
	case PlayStatusView::BogusStatus:
		return fView->MessageReceived(msg);

	default:
		inherited::MessageReceived(msg);
	}
}
