#ifndef TIMED_WINDOW_H
#define TIMED_WINDOW_H

#include <Locker.h>
#include <Window.h>

#include <vector>

class TimedWindow : public BWindow {
public:
	TimedWindow(BRect frame, const char *title, window_type type, uint32 flags, uint32 workspaces = B_CURRENT_WORKSPACE);
	TimedWindow(BRect frame, const char *title, window_look look, window_feel feel, uint32 flags, uint32 workspaces = B_CURRENT_WORKSPACE);
	~TimedWindow();

	enum {
		ShowWindow		= 'show',
		HideWindow		= 'hide'
	};

	void MessageReceived(BMessage *);
	void WorkspaceActivated(int32 workspace, bool active);

	virtual void Place();

	void SetAutoHiding(bool);

	void Show();
	void Hide();
	void HideIn(bigtime_t);
	void HideAt(bigtime_t);

	static void SetHideTime(bigtime_t);

private:
	void ConstructorCommon();
	static int32 WaiterFunc(void *);
	int32 WaiterFunc();

	static BLocker fAllTimedLock;
		static vector<TimedWindow *> fAllTimed;
		static bigtime_t fHideTime;
		static thread_id fWaiter;

		bigtime_t fWhenToHide;
		bool fAutoHiding;
};

#endif
