#include "FancyDebug.h"

#include <Application.h>
#include <View.h>
#include <Screen.h>
#include <StringView.h>

#include "VolumeWindow.h"
#include "VolumeView.h"
#include "Opcodes.h"

VolumeWindow::VolumeWindow()
	:	inherited(BRect(0, 0, 350, 25), "Volume", B_NO_BORDER_WINDOW_LOOK, 
			B_FLOATING_ALL_WINDOW_FEEL, B_ASYNCHRONOUS_CONTROLS
				| B_NOT_MOVABLE | B_NOT_CLOSABLE | B_NOT_ZOOMABLE
				| B_NOT_MINIMIZABLE | B_NOT_RESIZABLE | B_AVOID_FOCUS 
				| B_WILL_ACCEPT_FIRST_CLICK, B_ALL_WORKSPACES)
{	ENTRY

	Lock();

	BView *base = new BView(Bounds(), NULL, B_FOLLOW_ALL, B_WILL_DRAW);
	base->SetViewColor(0,0,0);
	AddChild(base);

	BStringView *sv = new BStringView(BRect(2,0,10,10), NULL, "Volume");
	BFont f(be_plain_font);
	f.SetSize(15);
	f.SetFace(B_BOLD_FACE);
	sv->SetFont(&f);
	sv->SetViewColor(0,0,0);
	sv->SetLowColor(0,0,0);
	sv->SetHighColor(50, 190, 255);
	base->AddChild(sv);
	sv->ResizeToPreferred();

	BRect frame = Bounds();
	frame.InsetBy(2,2);
	frame.left = sv->Frame().right+1;
	volumeView = new VolumeView(frame, "VolumeView");
	base->AddChild(volumeView);

	volumeView->MoveTo(sv->Frame().right+1, 2);
	ResizeTo(Frame().Width(), sv->Frame().Height());

	Place();

	Unlock();
}

void VolumeWindow::Place()
{	ENTRY

	Lock();
	ResizeTo(volumeView->Frame().right + 2, Frame().Height());
	inherited::Place();
	Unlock();
}

void VolumeWindow::MessageReceived(BMessage *msg)
{	ENTRY

	switch (msg->what) {
	case opcode::Mute:
	case opcode::VolumeUp:
	case opcode::VolumeDown:
		volumeView->MessageReceived(msg);
		break;

	default:
		TimedWindow::MessageReceived(msg);
	}
}
